%Frequenzstabilittsuntersuchung
%
%   28.11.2021          T. Weber    
%   13.04.2023          Zeitachse hinzugefgt

close all;
clear;

cnt = 'none'; % SELECT YOUR FREQUENCY COUNTER HERE

tau = 0.001; % Mittelungsdauer
k = 500000; % Anzahl der Messungen, beachte GPIB-Timeout

% Verbindung zum Frequenzzhler aufbauen
obj = cnt_connect(cnt);

% Frequenzzhler fr kontinuierliche Frequenzmessung konfigurieren
tau = cnt_parameters(obj,tau);

% Frequenzmessungen durchfhren
tic
[frequency,time,k] = cnt_frequency(obj,k,'frequency.txt');
toc
f0 = mean(frequency); % Mittenfrequenz
tau = (time(end)-time(1))/(k-1); % tatschliche Mittelungsdauer

% Verbindung zum Frequenzzhler schlieen
cnt_disconnect(obj);

% Frequenz zeichnen
figure;
plot(time,frequency/f0-1,'b-');

% formatieren
axis([time(1) time(end) -max(abs(frequency/f0-1)) max(abs(frequency/f0-1))]);
grid on;
xlabel('t/s');
ylabel('y');

% Allan-Deviation berechnen
[adev,tau] = allan(frequency/f0-1,tau);
data = [tau(:),adev(:)];
save('adev.txt','data','-ascii');

% Allan-Deviation zeichnen
figure;
loglog(tau,adev,'b-x');

% formatieren
grid on;
xlabel('\tau/s');
ylabel('\sigma_y');
